package top.ivan.demo.springboot;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Import;
import top.ivan.demo.springboot.mapper.MultiDataSourceRegister;
import top.ivan.demo.springboot.mapper.PerviewMapperImpl;
import top.ivan.demo.springboot.mapper.PreviewMapper;
import top.ivan.demo.springboot.mapper.TestConfig;

import javax.sql.DataSource;
import java.sql.PreparedStatement;
import java.util.concurrent.Executors;

@SpringBootApplication
@Import(MultiDataSourceRegister.class)
public class SpringbootApplication implements CommandLineRunner {

    @Autowired
    private PreviewMapper previewMapper;
//    @Autowired
//    private PerviewMapperImpl perviewMapper;
    @Autowired
    private DataSource dataSource;


    @Value("${spring.datasource.username}")
    private String name;

    public static void main(String[] args) {
        long st = System.currentTimeMillis();
        SpringApplication.run(SpringbootApplication.class, args);
        System.out.println("cost " + (System.currentTimeMillis() - st) + " ms");
    }

    @Override
    public void run(String... args) throws Exception {
        System.out.println(dataSource);
        System.out.println(previewMapper.getList(1,10,"ds1"));
        System.out.println(previewMapper.getList2(1,10));
        System.out.println(previewMapper.getList3(1,10));
    }
}
