package top.ivan.demo.springboot.controller;

import org.jsoup.Connection;
import org.jsoup.Jsoup;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import top.ivan.demo.springboot.pojo.ProductPreview;
import top.ivan.demo.springboot.service.TestService;

import java.io.IOException;
import java.time.LocalDate;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
public class MessageController {

    @Value("${top.ivan.demo.auth}")
    private String auth;
    @Value("${top.ivan.demo.password}")
    private String password;

    @RequestMapping("/support")
    @ResponseBody
    public Map<String,Object> support() {
        Map<String,Object> support = new HashMap<>();
        support.put("support",true);
        support.put("version",true);
        support.put("get",true);
        support.put("post",false);
        support.put("auth",auth);
        support.put("password",password);
        return support;
    }


    private static String url = "http://trains.ctrip.com/TrainBooking/Ajax/SearchListHandler.ashx?Action=getSearchList";
    private static String requestBody = "value={\"IsBus\":false,\"Filter\":\"0\",\"Catalog\":\"\",\"IsGaoTie\":false,\"IsDongChe\":false,\"CatalogName\":\"\",\"DepartureCity\":\"fuzhou\",\"ArrivalCity\":\"xiamen\",\"HubCity\":\"\",\"DepartureCityName\":\"福州\",\"ArrivalCityName\":\"厦门\",\"DepartureDate\":\"${startTime}\",\"DepartureDateReturn\":\"${endTime}\",\"ArrivalDate\":\"\",\"TrainNumber\":\"\"}";

    @RequestMapping("ticket")
    @ResponseBody
    public String ticket() throws IOException {
        String request = requestBody;
        LocalDate date = LocalDate.now();
        request = request.replace("${startTime}",date.toString());
        request = request.replace("${endTime}",date.plusDays(1).toString());
        Connection connection = Jsoup.connect(url);
        connection.header("Content-Type","application/x-www-form-urlencoded; charset=UTF-8")
                .header("Host"," trains.ctrip.com")
                .requestBody(request);
        return connection.post().text().toString();
    }

    @Autowired
    private TestService service;

    @RequestMapping("multi")
    @ResponseBody
    public Map<String,List<ProductPreview>> getList() {
        return service.getList();
    }


    @RequestMapping("multibyds")
    @ResponseBody
    public List<ProductPreview> getList(String ds) {
        return service.getList(ds);
    }
}
